from abc import ABC
from typing import List, cast

from kilroy_ws_server_py_sdk.handlers import Handler, HandlerWrapper


class Controller(ABC):
    def get_handlers(self) -> List[Handler]:
        return [
            cast(HandlerWrapper, getattr(self, name)).handler
            for name in dir(self)
            if name not in dir(Controller)
            and isinstance(getattr(self, name), HandlerWrapper)
        ]
