import inspect
from typing import Callable


def trail(path: str) -> str:
    return path if path.endswith("/") else path + "/"


def lead(path: str) -> str:
    return path if path.startswith("/") else "/" + path


def surround(path: str) -> str:
    return trail(lead(path))


def can_call_with_arg(f: Callable, arg_name: str) -> bool:
    try:
        inspect.signature(f).bind_partial(**{arg_name: None})
    except TypeError:
        return False

    return True
